"use strict";

require("core-js/modules/es.object.values");

require("core-js/modules/es.string.match");

require("core-js/modules/es.string.replace");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lang = require("../../lang");

var _matchVariable2 = _interopRequireDefault(require("./matchVariable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const evaluateVariableString = (variableString, data, context = {}) => {
  const _matchVariable = (0, _matchVariable2.default)(variableString),
        exact = _matchVariable.exact,
        expression = _matchVariable.expression,
        match = _matchVariable.match;

  if (!match) {
    return variableString;
  }

  const resolvedExpression = evaluateVariableString(expression, data);
  const self = (0, _lang.getProperty)('this', data);
  data = (0, _lang.omit)(['this'], data);
  const params = (0, _lang.concat)((0, _lang.keys)(data), Object.keys(context));
  const args = (0, _lang.concat)((0, _lang.values)(data), Object.values(context));
  const func = new Function(params, "return ".concat(resolvedExpression));
  let value = func.apply(self, args);

  if (!exact) {
    value = variableString.replace(match, value);
  }

  return value;
};

var _default = evaluateVariableString;
exports.default = _default;
//# sourceMappingURL=evaluateVariableString.js.map