"use strict";

require("core-js/modules/web.dom-collections.for-each");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ramda = require("ramda");

function toEqualPrintDiff(received, expecteds) {
  const options = {
    comment: 'Checks for a value equality between two objects and prints a usable diff',
    isNot: this.isNot,
    promise: this.promise
  };
  const expectedProps = (0, _ramda.keys)(expecteds);
  const foundProps = [];
  expectedProps.forEach(expectedProp => {
    const expected = expecteds[expectedProp];
    expect(received).toHaveProperty(expectedProp, expected);
    foundProps.push(expectedProp);
  });
  const remainingProps = (0, _ramda.keys)((0, _ramda.omit)(foundProps, received));
  const pass = remainingProps.length === 0;
  const message = pass ? () => this.utils.matcherHint('toHaveReturnedTruthyForValues', undefined, undefined, options) + '\n\n' + "Expected: ".concat(this.utils.printExpected(expecteds), "\n") + "Received: ".concat(this.utils.printReceived(received)) : () => this.utils.matcherHint('toBe', undefined, undefined, options) + '\n\n' + "Expected: ".concat(this.utils.printExpected(expecteds), "\n") + "Received: ".concat(this.utils.printReceived(received), "\n") + "Difference: Object contains the following unexpected properties ['".concat(remainingProps.join("', '"), "']");
  return {
    actual: received,
    message,
    pass
  };
}

var _default = toEqualPrintDiff;
exports.default = _default;
//# sourceMappingURL=toEqualPrintDiff.js.map